#ifndef _KEY_IN_H
#define _KEY_IN_H

#include "boolean.h"

#define MAX_CHOICE	16

typedef enum get_style {GetFlag, GetAlts, GetStr} get_style_t;

typedef struct point {
	   int x;
	   int y;
	} point_t;

typedef struct prmpt {
	   point_t pos;
	      char *s;
	} prmpt_t;

typedef struct choice {
	    int no;
	   char *msgs[MAX_CHOICE];
	} choice_t;

typedef union return_data {
	    int alts;
	   char str[32];
	} return_t;

typedef struct i_pat {
	   get_style_t style;
	       prmpt_t prmpt;
	       point_t pos;
	      choice_t choice;
	      return_t ret;
	     boolean_t (*func)();
	} i_pat_t;

typedef enum key_code {
		KEYMPREV = 60, KEYMNEXT = 61, KEYEXIT = 67,
		KEYUP    = 72, KEYDOWN  = 80, KEYLEFT = 75, KEYRIGHT = 77,
		KEYPGUP  = 73, KEYPGDN  = 81, KEYHOME = 71, KEYEND   = 79,
		KEYINS   = 82, KEYDEL   = 83, KEYRTN  = 13, KEYESC   = 27,
	     } key_code_t;

/* #define KEYUP    72
#define KEYDOWN  80
#define KEYLEFT  75
#define KEYRIGHT 77
#define KEYPGUP  73
#define KEYPGDN  81
#define KEYHOME  71
#define KEYEND   79 */
/* #define KEYMPREV 60 */   /* F2 */
/* #define KEYMNEXT 61 */  /* F3 */
/* #define KEYEXIT  67 */  /* F9 */

void setup_i_layout(char*, char*);
void setalts(i_pat_t*, int);
void setup_prompt(int, i_pat_t*);
key_code_t drive_input(int, i_pat_t*);

#endif _KEY_IN_H