#ifndef _QC_AD_H

#define _QC_AD_H

#include "macro_be.h"
#include "qc_adv.h"

#define AD_MAX_VOLTAGE 	  	10
#define AD_DOUBLE_MAX_VOLTAGE 	20
#define AD_BITS			12
#define AD_RANGE		4096L

#define AD_Config		"Advance AD Configuration"

#define AD_IN(port, channel, hi, lo) \
	MACRO_BEGIN \
	   outportb(port+2, channel); \
	   delay(5); \
	   outportb(port+3, 0xFF); \
	   delay(5); \
	   do { hi = inportb(port+3); delay(5); } while (hi >= 0x80); \
	   lo = inportb(port+2); \
	MACRO_END

#define AD_Decl_Used \
		char _Data[32]; \
	   const int _Len = 12; \
	    unsigned _Value; \
		long _Index;

#define AD_Real_Voltage(av, board, dvm) \
	MACRO_BEGIN \
	   read_dvm(board, dvm, _Data, _Len); \
	   av = atof(_Data); \
	MACRO_END

#define AD_Ideal_Voltage(cv, value, polar, range) \
	MACRO_BEGIN \
	   cv = (polar == UNIPOLAR) ? ((double)value * AD_MAX_VOLTAGE / (range - 1)) : \
		((double)value * AD_DOUBLE_MAX_VOLTAGE / (range - 1) - AD_MAX_VOLTAGE); \
	MACRO_END

#endif _QC_AD_H