#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <graphics.h>

#include "macro_be.h"
#include "sketch.h"

graph_env_t *get_graph_env(graph_env_t *env)
{
   env->max.x = getmaxx();
   env->max.y = getmaxy();

   return env;
}

void setup_diagram_layout(layout_t layout)
{
      int i, scale_ps, digit_no;
      int scale_posx, scale_posy;
      int y, ypoints;
      int x, xx;
     char scale_s[16];
   double scale_num, scale_offset;

   setbkcolor(layout.bkcolor);
   setcolor(layout.color);

   outtextxy(layout.title_pos.x, layout.title_pos.y, layout.title_str);
   outtextxy(layout.count_prmpt_pos.x, layout.count_prmpt_pos.y, layout.count_str);
   outtextxy(layout.value_prmpt_pos.x, layout.value_prmpt_pos.y, layout.value_str);

   scale_ps     = layout.scale_ps;
   scale_num    = layout.scale_ub;
   scale_offset = (layout.scale_ub - layout.scale_lb) / scale_ps;
   scale_posx   = layout.scale_pos.x;
   scale_posy   = layout.scale_pos.y;
   x            = layout.left_top.x;
   xx           = layout.right_bottom.x;
   y            = layout.left_top.y;
   ypoints      = (layout.right_bottom.y - layout.left_top.y) / scale_ps;
   for (i = 0; i <= scale_ps; i++,
	scale_num -= scale_offset, y += ypoints, scale_posy += ypoints) {
      if ((digit_no = sprintf(scale_s, "%6.3f", scale_num)) == EOF) {
	 fprintf(stderr, "Coversion in sprintf failed\n");
	 Close_graph
	 exit(1);
      }
      digit_no = layout.scale_dgt - digit_no;
      outtextxy(scale_posx + digit_no * DIGIT_WIDTH, scale_posy, scale_s);
      if (i == scale_ps) break;
      line(x, y, xx, y);
   }

   rectangle(layout.left_top.x, layout.left_top.y,
	     layout.right_bottom.x, layout.right_bottom.y);
}

/*void sketch_diagram(layout_t layout, unsigned bits)
{
   Decl_plot_vars

     double value;
       long i, range;
	int num, steps;

   range = 1 << bits;

   Init_plot_env(layout, range)

   randomize();
   for (i = 0; i < range; ++i) {
      num = rand() - RAND_MAX / 2;
      value = ((double)num / (double)RAND_MAX) / 100;

      Plot_variation(i, steps, value)

       if (kbhit())
	 if (getch() == 27) break;
   }
} */

void test_rand()
{
   int i, num, dec, sign;
   double value;
   char value_s[16];

   randomize();
   fprintf(stdout, "Max = %d\n", RAND_MAX);
   for (i = 0; i < 100; i++) {
      num = rand() - RAND_MAX / 2;
      value = ((double) num / (double)RAND_MAX) / 50;
      sprintf(value_s, "%9.6lf", value);
      fprintf(stdout, "num = %d value = %10.7f status = %d\t str = %s\n",
		       num, value, (value >= -0.01 && value <= 0.01),
		       value_s);
      if (getch() == 27) break;
   }
}

/* void main()
{
   graph_env_t env;
   layout_t layout;

   Init_graph

   get_graph_env(&env);
   get_diagram_layout(env, 8, -0.01, 0.01, &layout);
   setup_diagram_layout(layout);
   sketch_diagram(layout, 10);
   getch();
   Close_graph
} */